/* This file is part of the KDE project
   Copyright (C) 2003 Ignacio Castaño <castano@ludicon.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the Lesser GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
*/

// Install to C:\Qt\2009.03\qt\plugins\imageformats

#ifndef KIMG_DDS_H
#define KIMG_DDS_H

#include "ddshandler_global.h"
#include <QImageIOHandler>

class DDSHANDLER_EXPORT DDSHandler : public QImageIOHandler
{
public:
	DDSHandler();

	bool canRead() const;
	bool read(QImage *image);
	bool write(const QImage &image);

	QByteArray name() const;

	static bool canRead(QIODevice *device);
};


class DDSHANDLER_EXPORT DDSPlugin : public QImageIOPlugin
{
public:
	QStringList keys() const;
	Capabilities capabilities(QIODevice *device, const QByteArray &format) const;
	QImageIOHandler *create(QIODevice *device, const QByteArray &format = QByteArray()) const;
};


#endif

