uniform sampler2D intensitySampler;
uniform sampler2D heatMapSampler;

void main(void)
{
	// Get the intensity color
	vec4 intensityColor = texture2D(intensitySampler, gl_TexCoord[0].xy );
	
	// Map it to the "heat map" spectra
//	const vec4 maxHeatColor = vec4( 1, 0, 0, 0 );	// Red
//	const vec4 minHeatColor = vec4( 0, 0, 1, 0 );	// Blue
	
	// Compute final color
	// mix() == lerp()
	// vec4 finalColor = mix( minHeatColor, maxHeatColor, intensityColor.x );
	
	vec4 finalColor = texture2D(heatMapSampler, intensityColor.x );
	
	// Save the original alpha
	// finalColor.a = intensityColor.a;
	finalColor.a = intensityColor.a * finalColor.a;
		
	// Pass this out to the fragment processor
	gl_FragColor = finalColor;
}
