#include "EchoChamberSettings.h"

const char *stringListSettingsNames[EchoChamberSettings::SLS_COUNT] = {"Magnitude", "X", "Y", "Z", "Time", "Color" };

void EchoChamberSettings::Save(XMLSaver &xmlSaver)
{
	xmlSaver.CDDown(xmlSaver.MakeDirectory("EchoChamberSettings"));
	int versionNumber=0;
	XML_SAVER_SAVE_ELEMENT(xmlSaver, versionNumber);
	XML_SAVER_SAVE_ELEMENT(xmlSaver, functionCallQuery);
	XML_SAVER_SAVE_ELEMENT(xmlSaver, packetLogQuery);
	XML_SAVER_SAVE_ELEMENT(xmlSaver, networkStatisticsQuery);
	XML_SAVER_SAVE_ELEMENT(xmlSaver, postfixTickDefinition);
	int i;
	for (i=0; i < SLS_COUNT; i++)
		xmlSaver.SaveElement(stringListSettingsNames[i], stringListSettings[i]);
	xmlSaver.CDUp();
}

void EchoChamberSettings::Load(XMLSaver &xmlSaver)
{
	xmlSaver.CDDown("EchoChamberSettings");
	int i;
	int versionNumber;
	XML_SAVER_LOAD_ELEMENT(xmlSaver, versionNumber, "-1");
	XML_SAVER_LOAD_ELEMENT(xmlSaver, functionCallQuery, functionCallQuery);
	XML_SAVER_LOAD_ELEMENT(xmlSaver, packetLogQuery, packetLogQuery);
	XML_SAVER_LOAD_ELEMENT(xmlSaver, networkStatisticsQuery, networkStatisticsQuery);
	XML_SAVER_LOAD_ELEMENT(xmlSaver, postfixTickDefinition, postfixTickDefinition);
	for (i=0; i < SLS_COUNT; i++)
		xmlSaver.LoadElement(stringListSettingsNames[i], stringListSettings[i], true);
	xmlSaver.CDUp();
}
