#include "ISaveableWindow.h"

static ISaveableWindow *iSaveableHead=0;

ISaveableWindow *ISaveableWindow::GetLinkedList(void)
{
	return iSaveableHead;
}
ISaveableWindow::ISaveableWindow()
{
	next=0;
	if (iSaveableHead==0)
	{
		iSaveableHead=this;
	}
	else
	{
		ISaveableWindow *first = iSaveableHead;
		while (first->next)
			first=first->next;
		first->next=this;
	}
}
ISaveableWindow::~ISaveableWindow()
{
	if (iSaveableHead==this)
	{
		iSaveableHead=iSaveableHead->next;
	}
	else
	{
		ISaveableWindow *first = iSaveableHead;
		while (first->next!=this)
			first=first->next;
		first->next=first->next->next;
	}
}
void ISaveableWindow::SaveType(XMLSaver &xmlSaver)
{
	xmlSaver.SaveElement("WindowTypeId", GetWindowTypeId());
}
void ISaveableWindow::SaveVersion(XMLSaver &xmlSaver)
{
	xmlSaver.SaveElement("VersionNumber", GetVersionNumber());
}
void ISaveableWindow::SaveWindowTitle(XMLSaver &xmlSaver, QWidget *widget)
{
	xmlSaver.SaveElement("WindowTitle", widget->windowTitle());
}
QString ISaveableWindow::LoadWindowTitle(XMLSaver &xmlSaver)
{
	QString windowTitle;
	xmlSaver.LoadElement("WindowTitle", windowTitle, "Unknown window title");
	return windowTitle;
}
void ISaveableWindow::LoadType(XMLSaver &xmlSaver, WindowTypeId &windowTypeId)
{
	int wti;
	xmlSaver.LoadElement("WindowTypeId", wti, "-1");
	windowTypeId=(WindowTypeId) wti;
}
void ISaveableWindow::LoadVersion(XMLSaver &xmlSaver, int &version)
{
	xmlSaver.LoadElement("VersionNumber", version, "-1");
}
