#include <QDataStream>
#include <QWidget>
#include "XMLSaver.h"

#ifndef __ISAVEABLE_H
#define __ISAVEABLE_H

enum WindowTypeId
{
	WTI_SQL_QUERY_TOOL,
	WTI_PIE_WINDOW,
	WTI_QWT_WINDOW,
	WTI_SCATTER_PLOT_WINDOW,
	WTI_TABLE_WINDOW,
	WTI_IMAGE_VIEWER
};

class ISaveableWindow
{
public:
	ISaveableWindow();
	virtual ~ISaveableWindow();
	static ISaveableWindow *GetLinkedList(void);

	virtual void Save(XMLSaver &xmlSaver)=0;
	virtual void Load(XMLSaver &xmlSaver)=0;
	virtual WindowTypeId GetWindowTypeId(void) const=0;
	virtual int GetVersionNumber(void) const=0;
	void SaveType(XMLSaver &xmlSaver);
	void SaveVersion(XMLSaver &xmlSaver);
	void SaveWindowTitle(XMLSaver &xmlSaver, QWidget *widget);
	static QString LoadWindowTitle(XMLSaver &xmlSaver);
	static void LoadType(XMLSaver &xmlSaver, WindowTypeId &windowTypeId);
	static void LoadVersion(XMLSaver &xmlSaver, int &version);

	ISaveableWindow *next;
};

#endif
