#ifndef PIEWINDOW_H
#define PIEWINDOW_H

#include <QWidget>
#include <QSqlQuery>
#include <QSplitter>
#include <QTableView>
#include <QItemDelegate>
#include "QSqlQueryModelFetchAll.h"
#include "ui_PieWindow.h"
#include "AnimatedModelContainer.h"
#include "ISaveableWindow.h"

using namespace Ui;
class PieWidget;


/*
class ColorDecorationFromModel : public QItemDelegate
{
	Q_OBJECT
public:
	ColorDecorationFromModel(QWidget *parent, QSqlQueryModelFetchAll *_model, int dataColColumn) : QItemDelegate(parent), dataColorColumn(dataColColumn) {model=_model;}

	virtual void paint(QPainter *painter, const QStyleOptionViewItem &option,
		const QModelIndex &index) const;

	void SetDrawAsPrefix(bool b) {drawAsPrefix=b;}

protected:
	QSqlQueryModelFetchAll *model;
	const int dataColorColumn;
	bool drawAsPrefix;
};
*/


class PieWindow : public QMainWindow, public PieWindowClass, public ISaveableWindow, public AnimatedModelList, public AnimatedModel
{
	Q_OBJECT

public:
	PieWindow(QWidget* parent, Qt::WindowFlags f);
	void InitWithDb(QStringList queries, QStringList databaseNames);
	~PieWindow();

	void SetupComboBoxes(void);
	void ClearAnimationRowIndices(void);
	void SetAnimationRowIndices(int from, int to, double valueBefore, double valueAfter);
	virtual void Save(XMLSaver &xmlSaver);
	virtual void Load(XMLSaver &xmlSaver);
	virtual WindowTypeId GetWindowTypeId(void) const {return WTI_PIE_WINDOW;}
	virtual int GetVersionNumber(void) const {return 0;}
	
	virtual AnimatedModel* GetAnimatedModelAtIndex(int index) {return this;}
	virtual int GetAMCCount(void) const {return 1;}


	struct Row
	{
		QString label;
		double value;
		QColor color;
	};

	QList<Row> unsortedRows;
	QList<Row> sortedRows;
	int rowStart, rowEnd;
	double sumOfValues;

	public slots:
		void on_labelColumnCombobox_currentIndexChanged(QString string);
		void on_valueColumnCombobox_currentIndexChanged(QString string);
		void on_colorColumnCombobox_currentIndexChanged(QString string);
		void on_actionEdit_SQL_triggered(bool b);
		void on_actionEdit_Tick_triggered(bool b);
		void on_actionShow_Columns_toggled(bool b);

protected:

	void Recalcuate(void);

//	ColorDecorationFromModel *pvwd1;
	//QSqlQueryModelFetchAll model;
	PieWidget *pieWidget;
	bool disableRecalcuate;

};

#endif // PIEWINDOW_H
