#include "QSqlQueryModelFetchAll.h"
#include "EchoChamber.h"
#include <QSqlError>

void QSqlQueryModelFetchAll::setQuery(const QSqlQuery &_query)
{
	QSqlQueryModel::setQuery(_query);
}
void QSqlQueryModelFetchAll::setQuery(const QString &query, const QSqlDatabase &db)
{
//	QSqlQuery q(query,db);
//	q.setNumericalPrecisionPolicy(QSql::LowPrecisionDouble);
	QSqlQueryModel::setQuery(query,db);
}

int QSqlQueryModelFetchAll::realRowCount(const QModelIndex &parent)
{
	if (rowCount(parent)==0)
		return 0;

	while (canFetchMore())
		fetchMore();
	return rowCount(parent);
}

int QSqlQueryModelFetchAll::constrainedRowCount(int fullTableRowConstraint, const QModelIndex &parent)
{
	if (rowCount(parent)==0)
		return 0;

	int count=0;
	while (canFetchMore() && rowCount(parent)<fullTableRowConstraint)
	{
		fetchMore();
	}
	return rowCount(parent);
}
bool QSqlQueryModelFetchAll::GetNumericalColumnConstraints(int columnIndex, double *minimum, double *maximum)
{
	if (columnIndex==-1)
		return false;

	QModelIndex zeroIndex = index(0, columnIndex);
	QModelIndex maxIndex = index(realRowCount()-1, columnIndex);
	QVariant zeroVariant = data(zeroIndex);
	QVariant maxVariant = data(maxIndex);
	if (zeroVariant.isNull()==false &&
		maxVariant.isNull()==false &&
		zeroVariant.canConvert(QVariant::Double) &&
		maxVariant.canConvert(QVariant::Double))
	{
		double min,max;
		min=zeroVariant.toDouble();
		max=maxVariant.toDouble();
		if (max>=min)
		{
			*minimum = min;
			*maximum = max;
			return true;
		}
	}
	return false;
}
bool QSqlQueryModelFetchAll::GetNumericalColumnConstraints(QString columnName, double *minimum, double *maximum)
{
	if (columnName.isEmpty())
		return false;

	int columnIndex = EchoChamber::GetColumnIndex(this, columnName);
	return GetNumericalColumnConstraints(columnIndex,minimum,maximum);
}
