#ifndef SETTINGSSCREEN_H
#define SETTINGSSCREEN_H

#include <QDialog>
#include <QPlainTextEdit>
#include <QStringList>
#include "ui_SettingsScreen.h"
#include "EchoChamberSettings.h"

using namespace Ui;

class SettingsScreen : public QDialog, public SettingsScreenClass
{
	Q_OBJECT

public:
	SettingsScreen(QWidget* parent, Qt::WindowFlags f, const EchoChamberSettings& existingSettings);
	~SettingsScreen();

	static void SetQPlainTextEditFromQStringList(QPlainTextEdit *plainText, const QStringList &stringList);
	static void SetQStringListFromQPlainTextEdit(QPlainTextEdit *plainText, QStringList &stringList);

public slots:
	void on_buttonBox_accepted();
	void on_buttonBox_rejected();
	void on_postfixTickDefinitionLineEdit_textEdited(QString newString);

protected:
	EchoChamberSettings newSettings;
	void UpdatePostfixStatusButton(void);

};

#endif // SETTINGSSCREEN_H
