#include "StartupTips.h"
#include "EchoChamber.h"

extern EchoChamber *echoChamber;

#define NUM_TIPS 4
static const char *tips[NUM_TIPS]={
	"Press F1 and click to get context sensitive help",
	"The manual is located at http://www.jenkinssoftware.com/echochamber/manual",
	"Click file/load database to open an SQLite database. The RakNet projects to create databases can be found under Samples/SQLite3.",
	"Layouts can be used with different databases by loading the database(s) you want to use before loading the layout."
};

StartupTips::StartupTips(QWidget *parent, Qt::WindowFlags f)
	: QDialog(parent,f)
{
	setupUi(this);
	tipIndex=0;
	UpdateTextBrowserWithTip();
}

StartupTips::~StartupTips()
{
}
void StartupTips::on_nextTipPushButton_released()
{
	tipIndex--;
	if (tipIndex<0)
		tipIndex=NUM_TIPS-1;
	UpdateTextBrowserWithTip();

}
void StartupTips::on_previousTipPushButton_released()
{
	tipIndex++;
	if (tipIndex==NUM_TIPS)
		tipIndex=0;
	UpdateTextBrowserWithTip();
}
void StartupTips::on_showTipsOnStartupCheckBox_toggled(bool b)
{
	if (showTipsOnStartupCheckBox->isChecked()!=echoChamber->showTipsOnStartup)
	{
		echoChamber->showTipsOnStartup=showTipsOnStartupCheckBox->isChecked();
	}
}
void StartupTips::UpdateTextBrowserWithTip()
{
	textBrowser->setText(tips[tipIndex]);
}
