#include "WindowAdjustments.h"
#include "EchoChamber.h"
#include "OutputDebugString.h"

extern EchoChamber *echoChamber;

void ResizeContents(QWidget *widget,QWidget *proportionalSubWidget)
{
//	QRect resultRect = widget->geometry();
//	resultRect.moveTo(QPoint(100,100));
//	widget->setGeometry(QStyle::visualRect(echoChamber->GetWorkspace()->layoutDirection(), echoChamber->GetWorkspace()->rect(), resultRect));

	if (widget->isVisible()==false)
		return;
	QSize oldSize = widget->size();
	widget->adjustSize();
	if (proportionalSubWidget->height()<proportionalSubWidget->width())
	{
		widget->resize(widget->width(),widget->height()+proportionalSubWidget->width()-proportionalSubWidget->height());
	}
	else if (proportionalSubWidget->width()<proportionalSubWidget->height())
	{
		widget->resize(widget->width()+proportionalSubWidget->height()-proportionalSubWidget->width(),widget->height());
	}

	bool hasParent = widget->parent();
	QObject *parent = widget->parent();
	if (parent->isWidgetType())
		widget=(QWidget*)parent;

	int unknownHeightFix=54;

	int newX, newY;
	if (widget->x() + widget->frameSize().width() > echoChamber->width())
	{
		newX=echoChamber->width()-widget->frameSize().width();
		if (newX < 0)
			newX=0;
	}
	else
		newX=widget->x();

	if (widget->y() + widget->frameSize().height() > (echoChamber->height()-unknownHeightFix))
	{
		newY=(echoChamber->height()-unknownHeightFix)-widget->frameSize().height();
		if (newY < 0)
			newY=0;
	}
	else
		newY=widget->y();

	widget->move(newX, newY);

//	_OutputDebugString("ec=%i wid=%i\n", echoChamber->x(), widget->x());
}
