#ifndef __XML_SAVER_H
#define __XML_SAVER_H

#include <QtXml/QDomDocument>
#include <QStringList>
#include <QFile>

class QListWidget;
class QLineEdit;
class QtColorComboBox;
class QCheckBox;
class QSpinBox;
class QDoubleSpinBox;
class QTabWidget;
class QRadioButton;
class QComboBox;

#define XML_SAVER_LOAD_ELEMENT(xmlSaver, elementName, defaultValue) xmlSaver.LoadElement( #elementName, elementName, defaultValue );
#define XML_SAVER_SAVE_ELEMENT(xmlSaver, elementName) xmlSaver.SaveElement( #elementName, elementName );

class XMLSaver
{
public:
	XMLSaver(QString rootName);
	~XMLSaver();
	QDomElement MakeDirectory(QString elementName);
	void CDUp(void);
	bool CDNext(QString elementName);
	// This only goes down the first instance!
	bool CDDown(QString elementName);
	bool CDDown(QDomElement element);

	bool LoadFile(QString filename);
	bool SaveFile(QString filename);
	void LoadElement(QString elementName, bool &value, bool defaultValue);
	void LoadElement(QString elementName, QCheckBox *value, bool defaultValue);
	void LoadElement(QString elementName, int &value, QString defaultValue);
	void LoadElement(QString elementName, float &value, QString defaultValue);
	void LoadElement(QString elementName, QStringList &stringList, bool defaultToCurrentValues);
	void LoadElement(QString elementName, QList<int> &stringList, bool defaultToCurrentValues);
	void LoadElement(QString elementName, QListWidget *stringList, bool defaultToCurrentValues);
 	void LoadElement(QString elementName, QtColorComboBox *stringList, bool defaultToCurrentValues);
	void LoadElement(QString elementName, QString &value, QString defaultValue);
	void LoadElement(QString elementName, QComboBox *value, bool unused);
	void LoadElement(QString elementName, QLineEdit *value, QString defaultValue);
	void LoadElement(QString elementName, QByteArray &value, bool defaultToCurrentValues);
	void LoadElement(QString elementName, QSpinBox *value, QString defaultValue);
	void LoadElement(QString elementName, QDoubleSpinBox *value, QString defaultValue);
	void LoadElement(QString elementName, QTabWidget *value, QString defaultValue);
	void LoadElement(QString elementName, QRadioButton *value, bool defaultValue);

	// QtColorComboBox *

	

	void SaveElement(QString elementName, bool value);
	void SaveElement(QString elementName, QCheckBox *value);
	void SaveElement(QString elementName, int value);
	void SaveElement(QString elementName, float value);
	void SaveElement(QString elementName, QStringList stringList);
	void SaveElement(QString elementName, QList<int> &stringList);
	void SaveElement(QString elementName, QListWidget *stringList);
	void SaveElement(QString elementName, QtColorComboBox *stringList);
	void SaveElement(QString elementName, QString value);
	void SaveElement(QString elementName, QComboBox *value);
	void SaveElement(QString elementName, QLineEdit *value); 
	void SaveElement(QString elementName, QByteArray value);
	void SaveElement(QString elementName, QSpinBox *value);
	void SaveElement(QString elementName, QDoubleSpinBox *value);
	void SaveElement(QString elementName, QTabWidget *value);
	void SaveElement(QString elementName, QRadioButton *value);
protected:
	QDomDocument document;
	QDomElement root;
	QFile loadFile;

	QDomElement GetElement(QString elementName);
};

#endif
